PGOBLIN_BANG(-f)
 -- Copyright (C)2009..2022 @BABOLO http://www.babolo.ru/
 -- package = PKG
 -- All rights reserved.
 --
 -- Redistribution and use in source and binary forms, with or without
 -- modification, are permitted provided that the following conditions
 -- are met:
 -- 1. Redistributions of source code must retain the above copyright
 --    notice, this list of conditions and the following disclaimer.
 -- 2. Redistributions in binary form must reproduce the above copyright
 --    notice, this list of conditions and the following disclaimer in the
 --    documentation and/or other materials provided with the distribution.
 --
 -- THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 -- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 -- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 -- ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 -- FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 -- DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 -- OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 -- HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 -- LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 -- OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 -- SUCH DAMAGE.
 --
 -- $Id: cipalib.pgoblin.m4,v 1.15 2022/12/03 16:30:03 babolo Exp $

#connect 0001
sqlite2 :memory:
#perform 0001
PRAGMA default_temp_store = 2;
GETARG(a, 1, 1)
#perform 0001
CREATE TEMP TABLE CINM(x)(CIAT(x) text, CIAT(n) text, CIAT(p) text);
#-- x   
 -- x.x   DBinfra
 -- x.n  
 -- x.p    
#perform 0001
INSERT INTO CINM(x)
 SELECT (SELECT CIAT(a) FROM CINM(a) WHERE CIAT(i) = 0 LIMIT 1)
      , (SELECT CIAT(a) FROM CINM(a) WHERE CIAT(i) = 1 LIMIT 1)
      , (SELECT CIAT(a) FROM CINM(a) WHERE CIAT(i) = 2 LIMIT 1)
;
#perform 0001
UPDATE CINM(x) SET CIAT(p) = CIAT(p) || '/' WHERE NOT (CIAT(p) LIKE '%/');
#perform 0001
UPDATE CINM(x) SET CIAT(p) = '' WHERE CIAT(p) IS NULL;
#select 2001
SELECT '#!
##echo
No WWW DB suplied

##exit
1
'FROM CINM(x) WHERE CIAT(x) IS NULL
;
#eval 02
#select 2001
SELECT CIAT(x) FROM CINM(x);
#connect 0203
#perform 0003
CREATE TEMP TABLE CINM(x)(CIAT(x) text, CIAT(n) text, CIAT(p) text);
#close 202
#copyout 2001
COPY CINM(x) TO stdout;
#copyin 0023
COPY CINM(x) FROM stdin;
#--####################################################################################################
 --                                                              #
 --#############################################################################
#trap
#return
#perform 0003                                                                  ________(DBinfra, pvers)
CREATE TABLE CINM(pvers) --   
     ( CIAT(pkg)      text NOT NULL         --  
     , CIAT(protover) text                  --  
     , CIAT(major)    int  NOT NULL         --  
     , CIAT(minor)    text NOT NULL         --  
     , CIAT(comconf)  int                   --  
     , UNIQUE(CIAT(pkg), CIAT(protover)) ON CONFLICT REPLACE
     )
;
#-- pvers      
 -- pvers.pkg       
 -- pvers.protover  
 -- pvers.major     
 -- pvers.minor     
 -- pvers.comconf   
#untrap
#perform 0003                                                                  ________(DBinfra, pvers)
INSERT INTO CINM(pvers)(CIAT(pkg), CIAT(major), CIAT(minor))
 SELECT 'PKG', 0, '0'
  WHERE COALESCE(NOT (SELECT 1 FROM CINM(pvers) WHERE CINM(pvers).CIAT(pkg) = 'PKG'), 1)
;
#trap
#return
#perform 0003                                                                  ________(DBinfra, pnode)
CREATE TABLE CINM(pnode)
     ( CIAT(p)    INTEGER PRIMARY KEY ON CONFLICT REPLACE
     , CIAT(h)    text    NOT NULL
     , CIAT(b)    text
     , CIAT(m)    text    NOT NULL
     , CIAT(v)    text    NOT NULL
     , UNIQUE(CIAT(m), CIAT(v))
     )
;
#-- pnode  
 -- pnode.p  
 -- pnode.h 
 -- pnode.b  
 -- pnode.m  
 -- pnode.v    
#perform 0003                                                                   ________(DBinfra, pset)
CREATE TABLE CINM(pset)
     ( CIAT(l)    INTEGER PRIMARY KEY ON CONFLICT REPLACE
     , CIAT(t)    integer NOT NULL
     , CIAT(c)    text    NOT NULL
     , CIAT(m)    text    NOT NULL
     , CIAT(w)    text    NOT NULL
     , UNIQUE(CIAT(m), CIAT(w))
     )
;
#-- pset  
 -- pset.l   
 -- pset.t  
 -- pset.  
 -- pset.m  
 -- pset.w    
#perform 0003                                                                  ________(DBinfra, pleaf)
CREATE TABLE CINM(pleaf)
     ( CIAT(p)    integer NOT NULL REFERENCES CINM(pnode)(CIAT(p))
     , CIAT(r)    integer       -- REFERENCES CINM(pnode)(CIAT(p))  CINM(pregi)(CIAT(x))
     , CIAT(l)    integer          REFERENCES CINM(pset)(CIAT(l))
     , CIAT(o)    integer NOT NULL
     , CIAT(s)    text
     )
;
#-- pleaf  
 -- pleaf.p  
 -- pleaf.r     
 -- pleaf.l   
 -- pleaf.o    
 -- pleaf.s   
#perform 0003                                                                  ________(DBinfra, pcoll)
CREATE TABLE CINM(pcoll)
     ( CIAT(x)    INTEGER PRIMARY KEY ON CONFLICT REPLACE
     , CIAT(m)    text    NOT NULL
     , CIAT(u)    text    NOT NULL
     , UNIQUE(CIAT(m), CIAT(u))
     )
;
#-- pcoll  
 -- pcoll.x  
 -- pcoll.m  
 -- pcoll.u  
#perform 0003                                                                  ________(DBinfra, pregi)
CREATE TABLE CINM(pregi)
     ( CIAT(x)    integer NOT NULL REFERENCES CINM(pcoll)(CIAT(x))
     , CIAT(r)    integer NOT NULL REFERENCES CINM(pnode)(CIAT(p))
     , CIAT(o)    integer NOT NULL
     , CIAT(s)    text
     )
;
#-- pregi 
 -- pregi.x  
 -- pregi.r 
 -- pregi.o    
 -- pregi.s   
#perform 0003                                                                  ________(DBinfra, pbook)
CREATE TABLE CINM(pbook)
     ( CIAT(n)    text
     , CIAT(p)    integer NOT NULL UNIQUE ON CONFLICT REPLACE REFERENCES CINM(pnode)(CIAT(p))
     )
;
#-- pbook  
 -- pbook.n  
 -- pbook.p  
#perform 0003                                                                   ________(DBinfra, pnow)
CREATE TABLE CINM(pnow)
     ( CIAT(cred) integer UNIQUE ON CONFLICT REPLACE
     , CIAT(p)    integer NOT NULL REFERENCES CINM(pnode)(CIAT(p))
     )
;
#-- pnow     cred
 -- pnow.cred
 -- pnow.p
#untrap
#select  _003
SELECT CINM(pvers).CIAT(major) || '.' || CINM(pvers).CIAT(minor)
 FROM CINM(pvers)
 WHERE (CINM(pvers).CIAT(major) || '.' || CINM(pvers).CIAT(minor)) + 0.0 < 2.21
;
#eval    0_
##select  1003
SELECT CINM(pnow).CIAT(n), CINM(pnow).CIAT(p) FROM CINM(pbook) ORDER BY CINM(pnow).CIAT(n) IS NULL;
##perform 0003
DROP TABLE CINM(pbook);
##perform 0003
CREATE TABLE CINM(pbook)
     ( CIAT(n)    text
     , CIAT(p)    integer NOT NULL UNIQUE ON CONFLICT REPLACE REFERENCES CINM(pnode)(CIAT(p))
     )
;
##perform 0013
INSERT INTO CINM(pbook) VALUES(?, ?);
#close   101
#--####################################################################################################
 --                                                                   #
 --#############################################################################
#perform 0003
CREATE TEMP TABLE CINM(ps)
     ( CIAT(t)    integer NOT NULL
     , CIAT(c)    text
     , CIAT(w)    text    NOT NULL
     )
;
#-- ps   pset
 -- ps.t  
 -- ps.c  
 -- ps.w    

#perform 0003
CREATE TEMP TABLE CINM(pn)
     ( CIAT(v)    text    NOT NULL
     , CIAT(h)    text    NOT NULL
     )
;
#-- pn   pnode
 -- pn.v    
 -- pn.h 

#perform 0003
CREATE TEMP TABLE CINM(pl)
     ( CIAT(f)    integer NOT NULL
     , CIAT(o)    integer NOT NULL
     , CIAT(v)    text    NOT NULL
     , CIAT(m)    text
     , CIAT(w)    text    NOT NULL
     , CIAT(a)    text
     , CIAT(s)    text
     )
;
#-- pl   pleaf  pregi
 -- pl.f  
 -- pl.o    
 -- pl.v    
 -- pl.m     NULL   
 -- pl.w  
 -- pl.a - 
 -- pl.s HTTP GET 
#--####################################################################################################
 --                                                         #
 --#############################################################################
#cat 1
pnode
#copyin 0013
COPY CINM(pn) FROM stdin;
#close 101
#cat 1
pset
#copyin 0013
COPY CINM(ps) FROM stdin;
#close 101
#cat 1
pleaf
#copyin 0013
COPY CINM(pl) FROM stdin;
#close 101
#perform 0003 -------------------------------------------------------------------    
UPDATE CINM(pl)
   SET CIAT(m) = (SELECT CINM(x).CIAT(n) FROM CINM(x))
 WHERE CINM(pl).CIAT(m) IS NULL
;
#perform 0003 ------------------------------------   path      
UPDATE CINM(ps)
   SET CIAT(c) = (SELECT CINM(x).CIAT(p) FROM CINM(x)) || CINM(ps).CIAT(w)
 WHERE CINM(ps).CIAT(c) IS NULL
;
SEEPL(3)dnl                                                            ================================
#--####################################################################################################
 --                                                         #
 --#############################################################################
#perform 0003 ---------------------------------------------------------------    
INSERT OR IGNORE INTO CINM(pcoll)(CIAT(m), CIAT(u))
 SELECT CINM(x).CIAT(n)
      , CINM(pl).CIAT(w)
  FROM CINM(pl), CINM(x)
  WHERE CINM(pl).CIAT(f) = 3
;
#perform 0003 --------------------------------------------------------------     
INSERT OR IGNORE INTO CINM(pnode)(CIAT(h), CIAT(m), CIAT(v))
 SELECT CINM(pn).CIAT(h)
      , CINM(x).CIAT(n)
      , CINM(pn).CIAT(v)
  FROM CINM(pn), CINM(x)
;
#select 2003 ------------------------------------------------------       
SELECT CINM(ps).CIAT(t)
     , CINM(ps).CIAT(c)
     , CINM(x).CIAT(n)
     , CINM(ps).CIAT(w)
 FROM CINM(ps), CINM(x)
;
#perform 0023 -----------------------------------------------------------------------   
UPDATE CINM(pset)
   SET CIAT(t) = ?
     , CIAT(c) = ?
 WHERE CINM(pset).CIAT(m) = ?
   AND CINM(pset).CIAT(w) = ?
;
#perform 0023 ---------------------------------------------------------------------    
INSERT OR IGNORE INTO CINM(pset)(CIAT(t), CIAT(c), CIAT(m), CIAT(w))
 VALUES(?, ?, ?, ?)
;
#select 2003 --------------------------------------------------------------------------   
SELECT CINM(pn).CIAT(h)
     , CINM(x).CIAT(n)
     , CINM(pn).CIAT(v)
 FROM CINM(pn), CINM(x)
;
#perform 0023 ------------------------------------------------------------    
UPDATE CINM(pnode)
   SET CIAT(h) = ?
 WHERE CINM(pnode).CIAT(m) = ?
   AND CINM(pnode).CIAT(v) = ?
;
#--####################################################################################################
SEEPLEAF(3)dnl                                                         ================================
#perform 0003 ----------------------------------------    pleaf    
DELETE FROM CINM(pleaf)
 WHERE CIAT(p) IN(SELECT CINM(pnode).CIAT(p)
                   FROM CINM(pnode)
                   WHERE CINM(pnode).CIAT(m) = (SELECT CIAT(n) FROM CINM(x))
                 )
;
SEEPLEAF(3)dnl                                                         ================================
#perform 0003 ----------------------------------------    pregi    
DELETE FROM CINM(pregi)
 WHERE CIAT(r) IN(SELECT CINM(pnode).CIAT(p)
                   FROM CINM(pnode)
                   WHERE CINM(pnode).CIAT(m) = (SELECT CIAT(n) FROM CINM(x))
                 )
;
#perform 0003 ------------------------------------------------------------------     pl
INSERT INTO CINM(pleaf)(CIAT(p), CIAT(l), CIAT(o), CIAT(s))
 SELECT CINM(pnode).CIAT(p)
      , CINM(pset).CIAT(l)
      , CINM(pl).CIAT(o)
      , CINM(pl).CIAT(s)
  FROM CINM(pnode) JOIN CINM(pl) USING(CIAT(v)) JOIN CINM(pset) USING(CIAT(m), CIAT(w))
  WHERE CINM(pl).CIAT(f) = 1
    AND CINM(pnode).CIAT(m) = (SELECT CIAT(n) FROM CINM(x))
;
SEEPLEAF(3)dnl                                                         ================================
#perform 0003 ----------------------------------------------------------------------------   
INSERT INTO CINM(pleaf)(CIAT(p), CIAT(r), CIAT(o), CIAT(s))
 SELECT CINM(pnode).CIAT(p)
      , CINM(ref).CIAT(p)
      , CINM(pl).CIAT(o)
      , CINM(pl).CIAT(s)
  FROM  CINM(pnode)
   JOIN CINM(pl) USING(CIAT(v))
   JOIN CINM(pnode) AS CINM(ref)
     ON(CINM(pl).CIAT(m) = CINM(ref).CIAT(m) AND CINM(pl).CIAT(w) = CINM(ref).CIAT(v))
  WHERE CINM(pl).CIAT(f) = 2
    AND COALESCE( CINM(pnode).CIAT(m) = CINM(pl).CIAT(a)
                , CINM(pnode).CIAT(m) = (SELECT CIAT(n) FROM CINM(x))
                )
;
SEEPLEAF(3)dnl                                                         ================================
#perform 0003 ------------------------------------------------------------------    
INSERT INTO CINM(pleaf)(CIAT(p), CIAT(r), CIAT(l), CIAT(o), CIAT(s))
 SELECT CINM(pnode).CIAT(p)
      , CINM(pcoll).CIAT(x)
      , 0
      , CINM(pl).CIAT(o)
      , CINM(pl).CIAT(s)
  FROM  CINM(pnode)
   JOIN CINM(pl) USING(CIAT(v))
   JOIN CINM(pcoll) ON(CINM(pl).CIAT(w) = CINM(pcoll).CIAT(u))
  WHERE CINM(pl).CIAT(f) = 3
    AND CINM(pcoll).CIAT(m) = (SELECT CIAT(n) FROM CINM(x))
    AND COALESCE( CINM(pnode).CIAT(m) = CINM(pl).CIAT(a)
                , CINM(pnode).CIAT(m) = CINM(pcoll).CIAT(m)
                )
;
SEEPLEAF(3)dnl                                                         ================================
#perform 0003 -----------------------------------------------------------------------   
INSERT INTO CINM(pregi)(CIAT(x), CIAT(r), CIAT(o), CIAT(s))
 SELECT CINM(pcoll).CIAT(x)
      , CINM(pnode).CIAT(p)
      , CINM(pl).CIAT(o)
      , CINM(pl).CIAT(s)
  FROM  CINM(pnode)
   JOIN CINM(pl) USING(CIAT(v))
   JOIN CINM(pcoll) ON(   CINM(pl).CIAT(w) = CINM(pcoll).CIAT(u)
                      AND CINM(pl).CIAT(m) = CINM(pcoll).CIAT(m)
                      )
  WHERE CINM(pl).CIAT(f) = 4
    AND COALESCE( CINM(pnode).CIAT(m) = CINM(pl).CIAT(a)
                , CINM(pnode).CIAT(m) = (SELECT CIAT(n) FROM CINM(x))
                )
;
#perform 0003 -------    ,      ,    ps
DELETE FROM CINM(pnode)
 WHERE CIAT(p)IN(SELECT CINM(pleaf).CIAT(p)
                  FROM CINM(pleaf)
                  WHERE CINM(pleaf).CIAT(l)IN(SELECT CINM(pset).CIAT(l)
                                               FROM CINM(pset)
                                               WHERE CINM(pset).CIAT(m) = (SELECT CIAT(n) FROM CINM(x))
                                                 AND CINM(pset).CIAT(w)NOT IN(SELECT CINM(ps).CIAT(w)
                                                                               FROM CINM(ps)
                )                            )                               )
;
#perform 0003 ------------------------------------     ,    ps
DELETE FROM CINM(pleaf)
 WHERE CIAT(l) IN(SELECT CINM(pset).CIAT(l)
                   FROM CINM(pset)
                   WHERE CINM(pset).CIAT(m) == (SELECT CIAT(n) FROM CINM(x))
                     AND CINM(pset).CIAT(w) NOT IN(SELECT CINM(ps).CIAT(w) FROM CINM(ps))
                 )
;
SEEPLEAF(3)dnl                                                         ================================
#perform 0003 ---------------------------------------------------   ,    pn
DELETE FROM CINM(pnode)
 WHERE CIAT(m) = (SELECT CIAT(n) FROM CINM(x))
   AND CIAT(v) NOT IN(SELECT CINM(pn).CIAT(v) FROM CINM(pn))
;
#perform 0003 -------------------------------------------------  ,    ps
DELETE FROM CINM(pset)
 WHERE CIAT(m) = (SELECT CIAT(n) FROM CINM(x))
   AND CIAT(w) NOT IN(SELECT CINM(ps).CIAT(w) FROM CINM(ps))
;
#select  _001
SELECT CINM(x).CIAT(n), CINM(x).CIAT(n) FROM CINM(x);
#perform 00_3
INSERT INTO CINM(pvers)(CIAT(pkg), CIAT(major), CIAT(minor))
 SELECT ?, 0, '0'
  WHERE COALESCE(NOT (SELECT 1 FROM CINM(pvers) WHERE CINM(pvers).CIAT(pkg) = ?), 1)
;
#begin
#perform 0003
DELETE FROM CINM(pvers) WHERE CIAT(pkg) == 'PKG';
#perform 0003
INSERT INTO CINM(pvers)(CIAT(pkg), CIAT(major), CIAT(minor)) SELECT 'PKG', VMAJOR, 'VMINOR';
#end
